#include <amxmodx>

#define VOL 1.0	// radio volume

new const AUDIOTEXT[][] =
{
	"COVERME",
	"TAKEPOINT",
	"POSITION",
	"REGROUP",
	"FOLLOWME",
	"HITASSIST",
	"GO",
	"FALLBACK",
	"STICKTOG",
	"GETINPOS",
	"STORMFRONT",
	"REPORTIN",
	"AFFIRM",
	"ROGER",
	"ENEMYSPOT",
	"BACKUP",
	"CLEAR",
	"INPOS",
	"REPRTINGIN",
	"BLOW",
	"NEGATIVE",
	"ENEMYDOWN",
//	"FIREINHOLE",
	"LETSGO",
	"LOCKNLOAD",
	"MOVEOUT"
}

new const AUDIOT[][] =
{
	"radio/t/ct_coverme.wav",
	"radio/t/takepoint.wav",
	"radio/t/position.wav",
	"radio/t/regroup.wav",
	"radio/t/followme.wav",
	"radio/t/fireassis.wav",
	"radio/t/com_go.wav",
	"radio/t/fallback.wav",
	"radio/t/sticktog.wav",
	"radio/t/com_getinpos.wav",
	"radio/t/stormfront.wav",
	"radio/t/com_reportin.wav",
	"radio/t/ct_affirm.wav",
	"radio/t/roger.wav",
	"radio/t/ct_enemys.wav",
	"radio/t/ct_backup.wav",
	"radio/t/clear.wav",
	"radio/t/ct_inpos.wav",
	"radio/t/ct_reportingin.wav",
	"radio/t/blow.wav",
	"radio/t/negative.wav",
	"radio/t/enemydown.wav",
//	"radio/t/ct_fireinhole.wav",
	"radio/t/letsgo.wav",
	"radio/t/locknload.wav",
	"radio/t/moveout.wav"
}

new const AUDIOCT[][] =
{
	"radio/ct/ct_coverme.wav",
	"radio/ct/takepoint.wav",
	"radio/ct/position.wav",
	"radio/ct/regroup.wav",
	"radio/ct/followme.wav",
	"radio/ct/fireassis.wav",
	"radio/ct/com_go.wav",
	"radio/ct/fallback.wav",
	"radio/ct/sticktog.wav",
	"radio/ct/com_getinpos.wav",
	"radio/ct/stormfront.wav",
	"radio/ct/com_reportin.wav",
	"radio/ct/ct_affirm.wav",
	"radio/ct/roger.wav",
	"radio/ct/ct_enemys.wav",
	"radio/ct/ct_backup.wav",
	"radio/ct/clear.wav",
	"radio/ct/ct_inpos.wav",
	"radio/ct/ct_reportingin.wav",
	"radio/ct/blow.wav",
	"radio/ct/negative.wav",
	"radio/ct/enemydown.wav",
//	"radio/ct/ct_fireinhole.wav",
	"radio/ct/letsgo.wav",
	"radio/ct/locknload.wav",
	"radio/ct/moveout.wav"
}

new g_msgSendAudio

public plugin_precache()
{
	for(new i=0; i<sizeof AUDIOT; i++)
	{
		precache_sound(AUDIOT[i])
		precache_sound(AUDIOCT[i])
	}
}

new c_reborn, c_hear

public plugin_init()
{
	register_plugin("Real Radio Reborn!", "0.62", "se7h")

	g_msgSendAudio = get_user_msgid("SendAudio")

	register_message(g_msgSendAudio, "sound_radio")

	c_reborn = register_cvar("amx_real_radio_reborn", "1")	// 1/0 - on/off plugin
	c_hear = register_cvar("rrr_hear_on_distance", "2")		// 0 - not hear radio on distance in air, 1 - hear radio on distance in air, 2 - hear only sender radio on distance in air
}

public sound_radio(msg_id, msg_dest, id)
{
	if(!get_pcvar_num(c_reborn))
		return PLUGIN_CONTINUE

	static idsender, rcmd[32], i, team

	idsender = get_msg_arg_int(1)

	get_msg_arg_string(2, rcmd, 31)

	team = get_user_team(id)

	if(!equal(rcmd, "%!MRAD_", 7))
		return PLUGIN_CONTINUE

	for(i=0; i<sizeof AUDIOTEXT; i++)
	{
		if(equal(rcmd[7], AUDIOTEXT[i]))
			break
	}

	if(i == sizeof AUDIOTEXT)
		return PLUGIN_CONTINUE

	if(is_user_alive(id))
	{
		switch(get_pcvar_num(c_hear))
		{
			case 0:
			{
				switch(team)
				{
					case 1: client_cmd(id, "spk %s", AUDIOT[i])
					case 2: client_cmd(id, "spk %s", AUDIOCT[i])
				}
			}
			case 1:
			{
				switch(team)
				{
					case 1: emit_sound(id, CHAN_AUTO, AUDIOT[i], VOL, 2.0, 0, PITCH_NORM)
					case 2: emit_sound(id, CHAN_AUTO, AUDIOCT[i], VOL, 2.0, 0, PITCH_NORM)
				}
			}
			case 2:
			{
				switch(team)
				{
					case 1:
					{
						if(idsender == id)
							emit_sound(id, CHAN_AUTO, AUDIOT[i], VOL, 2.0, 0, PITCH_NORM)
						else
							client_cmd(id, "spk %s", AUDIOT[i])
					}
					case 2:
					{
						if(idsender == id)
							emit_sound(id, CHAN_AUTO, AUDIOCT[i], VOL, 2.0, 0, PITCH_NORM)
						else
							client_cmd(id, "spk %s", AUDIOCT[i])
					}
				}
			}
		}
	}else{
		switch(team)
		{
			case 1: client_cmd(id, "spk %s", AUDIOT[i])
			case 2: client_cmd(id, "spk %s", AUDIOCT[i])
		}
	}

	if(idsender != id)
		radio_off(idsender, id)

	return PLUGIN_HANDLED
}

stock radio_off(idsender, id)
{
	message_begin(MSG_ONE, g_msgSendAudio, {0, 0, 0}, id)
	write_byte(idsender)
	write_string("%!MRAD_")
	write_short(32767)
	message_end()
}
